import System (getArgs, ExitCode(ExitSuccess),exitWith)
import qualified Gtk(WindowType(..),vBoxNew,containerBorderWidth,init,
		     adjustmentNew,textNew,textSetEditable,containerAdd,
		     menuBarNew,menuItemNewWithLabel,menuBarAppend,
		     menuNew,menuAppend,menuItemRightJustify,
		     signalConnect,MenuItemSignalHandler(..),
		     menuItemSetSubmenu,widgetShow,windowSetTitle,windowNew,
		     boxPackStart,main,exit)
main :: IO ()
main  = do
          preArgs <- getArgs
	  _ <- Gtk.init (Just ("", preArgs))

          window <- Gtk.windowNew Gtk.WindowToplevel
	  Gtk.windowSetTitle window "MenuTest"
	  Gtk.containerBorderWidth window 0
          Gtk.widgetShow window

          bigVBox <- Gtk.vBoxNew False 0
	  Gtk.containerAdd window bigVBox
          Gtk.widgetShow bigVBox

          myMen <- Gtk.menuBarNew
	  Gtk.widgetShow myMen
	  Gtk.boxPackStart bigVBox myMen False False 0 


          sysRootMenIt <- Gtk.menuItemNewWithLabel "System"
	  Gtk.menuBarAppend myMen sysRootMenIt
	  sysRootMen <- Gtk.menuNew
	  Gtk.menuItemSetSubmenu sysRootMenIt sysRootMen
	  Gtk.widgetShow sysRootMenIt


          quitMenIt <- Gtk.menuItemNewWithLabel "Quit"
	  Gtk.menuAppend sysRootMen quitMenIt
	  Gtk.widgetShow quitMenIt
	  Gtk.signalConnect quitMenIt (Gtk.MenuItemActivateHandler 
					       (const (Gtk.exit ExitSuccess)))


          helpMenIt <- Gtk.menuItemNewWithLabel "About"
	  helpMen <- Gtk.menuNew
	  Gtk.menuBarAppend myMen helpMenIt
	  Gtk.menuItemSetSubmenu helpMenIt helpMen
	  Gtk.menuItemRightJustify helpMenIt
	  Gtk.widgetShow helpMen
	  Gtk.widgetShow helpMenIt
	     
          aboutMeIt <- Gtk.menuItemNewWithLabel "About"
	  Gtk.menuAppend helpMen aboutMeIt
	  Gtk.widgetShow aboutMeIt



	  edit_adj <- Gtk.adjustmentNew 1.0 0.0 2.0 0.1 1.0 2.0
	  edit_text <- Gtk.textNew (Just edit_adj) Nothing
	  Gtk.textSetEditable edit_text True
	  Gtk.boxPackStart bigVBox edit_text True True 0 
	  Gtk.widgetShow edit_text


	  Gtk.main
	  exitWith ExitSuccess

