-- The enhanced infamous `Hello World!' program using the GTK binding for
-- Haskell 
--
--    ghc -o hello2 -fglasgow-exts -i.. -L.. -lgtkHS GtkHelloWorld2.hs\
--      `gtk-config --cflags` `gtk-config --libs`
--

import System (getArgs, ExitCode(ExitSuccess))
import Gtk    (WindowType(..),
	       Button, buttonNewWithLabel,
	       ButtonSignalHandler(..), signalConnect,
	       Container, containerSetBorderWidth, containerAdd,
	       Widget, widgetShow,
	       Window, windowNew)
import qualified
       Gtk    (init, main, exit)

hello :: IO ()
hello  = do
	   putStr "Hello World!\n"
	   Gtk.exit ExitSuccess

main :: IO ()
main  = do
	  Gtk.init Nothing

	  window <- windowNew WindowToplevel
	  containerSetBorderWidth window 10

	  button <- buttonNewWithLabel "Hello World!"
	  signalConnect button (ButtonClickedHandler (const hello))
	  containerAdd window button
	  widgetShow button

	  widgetShow window

	  Gtk.main
